Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# vtkImageExport Class Reference

`#include <vtkImageExport.h>`

Inheritance diagram for vtkImageExport:

[legend]
Collaboration diagram for vtkImageExport:

[legend]
List of all members.

## Detailed Description

Export VTK images to third-party systems.

Date:
  2002/12/11 14:26:22

Revision:
  1.30

vtkImageExport provides a way of exporting image data at the end of a pipeline to a third-party system or to a simple C array. Applications can use this to get direct access to the image data in memory. A callback interface is provided to allow connection of the VTK pipeline to a third-party pipeline. This interface conforms to the interface of vtkImageImport. In Python it is possible to use this class to write the image data into a python string that has been pre-allocated to be the correct size.

See also:
  vtkImageImport

Created by:
  - Law, Charles

CVS contributions (if > 5%):
  - Gobbi, David (45%)
  - Law, Charles (26%)
  - King, Brad (17%)
  - Cedilnik, Andy (6%)

CVS logs (CVSweb):
  - .`cxx` (`/Imaging/vtkImageExport.cxx)`
  - .`h` (`/Imaging/vtkImageExport.h)`

Tests:
  vtkImageExport (Tests)

Definition at line 58 of file vtkImageExport.h.

## Public Types
typedef vtkProcessObject | Superclass
typedef void(* | UpdateInformationCallbackType )(void *)
typedef int(* | PipelineModifiedCallbackType )(void *)
typedef int *(* | WholeExtentCallbackType )(void *)
typedef float *(* | SpacingCallbackType )(void *)
typedef float *(* | OriginCallbackType )(void *)
typedef const char *(* | ScalarTypeCallbackType )(void *)
typedef int(* | NumberOfComponentsCallbackType )(void *)
typedef void(* | PropagateUpdateExtentCallbackType )(void *, int *)
typedef void(* | UpdateDataCallbackType )(void *)
typedef int *(* | DataExtentCallbackType )(void *)
typedef void *(* | BufferPointerCallbackType )(void *)
## Public Methods
virtual const char * | GetClassName ()
virtual int | IsA (const char *type)
void | PrintSelf (ostream &os, vtkIndent indent)
int | GetDataMemorySize ()
int | GetDataNumberOfScalarComponents ()
void * | GetPointerToData ()
void * | GetCallbackUserData ()
void | GetDataDimensions (int *ptr)
int * | GetDataDimensions ()
int | GetDataScalarType ()
const char * | GetDataScalarTypeAsString ()
int * | GetDataExtent ()
void | GetDataExtent (int *ptr)
float * | GetDataSpacing ()
void | GetDataSpacing (float *ptr)
float * | GetDataOrigin ()
void | GetDataOrigin (float *ptr)
void | SetInput (vtkImageData *input)
vtkImageData * | GetInput ()
virtual void | ImageLowerLeftOn ()
virtual void | ImageLowerLeftOff ()
virtual int | GetImageLowerLeft ()
virtual void | SetImageLowerLeft (int)
void | SetExportVoidPointer (void *)
void * | GetExportVoidPointer ()
void | Export ()
virtual void | Export (void *)
UpdateInformationCallbackType | GetUpdateInformationCallback () const
PipelineModifiedCallbackType | GetPipelineModifiedCallback () const
WholeExtentCallbackType | GetWholeExtentCallback () const
SpacingCallbackType | GetSpacingCallback () const
OriginCallbackType | GetOriginCallback () const
ScalarTypeCallbackType | GetScalarTypeCallback () const
NumberOfComponentsCallbackType | GetNumberOfComponentsCallback () const
PropagateUpdateExtentCallbackType | GetPropagateUpdateExtentCallback () const
UpdateDataCallbackType | GetUpdateDataCallback () const
DataExtentCallbackType | GetDataExtentCallback () const
BufferPointerCallbackType | GetBufferPointerCallback () const
## Static Public Methods
vtkImageExport * | New ()
int | IsTypeOf (const char *type)
vtkImageExport * | SafeDownCast (vtkObject *o)
## Protected Methods
| vtkImageExport ()
| ~vtkImageExport ()
virtual void | UpdateInformationCallback ()
virtual int | PipelineModifiedCallback ()
virtual void | UpdateDataCallback ()
virtual int * | WholeExtentCallback ()
virtual float * | SpacingCallback ()
virtual float * | OriginCallback ()
virtual const char * | ScalarTypeCallback ()
virtual int | NumberOfComponentsCallback ()
virtual void | PropagateUpdateExtentCallback (int *)
virtual int * | DataExtentCallback ()
virtual void * | BufferPointerCallback ()
## Protected Attributes
int | ImageLowerLeft
int | DataDimensions [3]
void * | ExportVoidPointer
unsigned long | LastPipelineMTime

## Member Typedef Documentation

typedef vtkProcessObject vtkImageExport::Superclass

| Reimplemented from vtkProcessObject. Definition at line 62 of file vtkImageExport.h.

typedef void(* vtkImageExport::UpdateInformationCallbackType)(void*)

| These are function pointer types for the pipeline connection callbacks. See furhter documentation in vtkImageImport.h. Definition at line 146 of file vtkImageExport.h.

typedef int(* vtkImageExport::PipelineModifiedCallbackType)(void*)

| These are function pointer types for the pipeline connection callbacks. See furhter documentation in vtkImageImport.h. Definition at line 147 of file vtkImageExport.h.

typedef int*(* vtkImageExport::WholeExtentCallbackType)(void*)

| These are function pointer types for the pipeline connection callbacks. See furhter documentation in vtkImageImport.h. Definition at line 148 of file vtkImageExport.h.

typedef float*(* vtkImageExport::SpacingCallbackType)(void*)

| These are function pointer types for the pipeline connection callbacks. See furhter documentation in vtkImageImport.h. Definition at line 149 of file vtkImageExport.h.

typedef float*(* vtkImageExport::OriginCallbackType)(void*)

| These are function pointer types for the pipeline connection callbacks. See furhter documentation in vtkImageImport.h. Definition at line 150 of file vtkImageExport.h.

typedef const char*(* vtkImageExport::ScalarTypeCallbackType)(void*)

| These are function pointer types for the pipeline connection callbacks. See furhter documentation in vtkImageImport.h. Definition at line 151 of file vtkImageExport.h.

typedef int(* vtkImageExport::NumberOfComponentsCallbackType)(void*)

| These are function pointer types for the pipeline connection callbacks. See furhter documentation in vtkImageImport.h. Definition at line 152 of file vtkImageExport.h.

typedef void(* vtkImageExport::PropagateUpdateExtentCallbackType)(void*, int*)

| These are function pointer types for the pipeline connection callbacks. See furhter documentation in vtkImageImport.h. Definition at line 153 of file vtkImageExport.h.

typedef void(* vtkImageExport::UpdateDataCallbackType)(void*)

| These are function pointer types for the pipeline connection callbacks. See furhter documentation in vtkImageImport.h. Definition at line 154 of file vtkImageExport.h.

typedef int*(* vtkImageExport::DataExtentCallbackType)(void*)

| These are function pointer types for the pipeline connection callbacks. See furhter documentation in vtkImageImport.h. Definition at line 155 of file vtkImageExport.h.

typedef void*(* vtkImageExport::BufferPointerCallbackType)(void*)

| These are function pointer types for the pipeline connection callbacks. See furhter documentation in vtkImageImport.h. Definition at line 156 of file vtkImageExport.h.

## Constructor & Destructor Documentation

vtkImageExport::vtkImageExport | ( |  | ) | `[protected]`

vtkImageExport::~vtkImageExport | ( |  | ) | `[protected]`

## Member Function Documentation

vtkImageExport* vtkImageExport::New | ( |  | ) | `[static]`

| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. Reimplemented from vtkObject.

virtual const char* vtkImageExport::GetClassName | ( |  | ) | `[virtual]`

| Reimplemented from vtkProcessObject.

int vtkImageExport::IsTypeOf | ( | const char * | type | ) | `[static]`

| Return 1 if this class type is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkProcessObject.

virtual int vtkImageExport::IsA | ( | const char * | type | ) | `[virtual]`

| Return 1 if this class is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkProcessObject.

vtkImageExport* vtkImageExport::SafeDownCast | ( | vtkObject * | o | ) | `[static]`

| Reimplemented from vtkProcessObject.

void vtkImageExport::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) | `[virtual]`

| Methods invoked by print to print information about the object including superclasses. Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes. Reimplemented from vtkProcessObject.

int vtkImageExport::GetDataMemorySize | ( |  | ) |

| Get the number of bytes required for the output C array.

void vtkImageExport::GetDataDimensions | ( | int * | ptr | ) |

| Get the (x,y,z) index dimensions of the data. Please note that C arrays are indexed in decreasing order, i.e. array[z][y][x].

int* vtkImageExport::GetDataDimensions | ( |  | ) | `[inline]`

| Get the (x,y,z) index dimensions of the data. Please note that C arrays are indexed in decreasing order, i.e. array[z][y][x]. Definition at line 72 of file vtkImageExport.h.

int vtkImageExport::GetDataNumberOfScalarComponents | ( |  | ) |

| Get the number of scalar components of the data. Please note that when you index into a C array, the scalar component index comes last, i.e. array[z][y][x][c].

int vtkImageExport::GetDataScalarType | ( |  | ) |

| Get the scalar type of the data. The scalar type of the C array must match the scalar type of the data.

const char* vtkImageExport::GetDataScalarTypeAsString | ( |  | ) | `[inline]`

| Get the scalar type of the data. The scalar type of the C array must match the scalar type of the data. Definition at line 86 of file vtkImageExport.h.

int* vtkImageExport::GetDataExtent | ( |  | ) |

| Get miscellaneous additional information about the data.

void vtkImageExport::GetDataExtent | ( | int * | ptr | ) |

| Get miscellaneous additional information about the data.

float* vtkImageExport::GetDataSpacing | ( |  | ) |

| Get miscellaneous additional information about the data.

void vtkImageExport::GetDataSpacing | ( | float * | ptr | ) |

| Get miscellaneous additional information about the data.

float* vtkImageExport::GetDataOrigin | ( |  | ) |

| Get miscellaneous additional information about the data.

void vtkImageExport::GetDataOrigin | ( | float * | ptr | ) |

| Get miscellaneous additional information about the data.

void vtkImageExport::SetInput | ( | vtkImageData * | input | ) |

| Set/Get the input object from the image pipeline.

vtkImageData* vtkImageExport::GetInput | ( |  | ) |

| Set/Get the input object from the image pipeline.

virtual void vtkImageExport::ImageLowerLeftOn | ( |  | ) | `[virtual]`

| Set/Get whether the data goes to the exported memory starting in the lower left corner or upper left corner. Default: On. When this flag is Off, the image will be flipped vertically before it is exported. WARNING: this flag is used only with the Export() method, it is ignored by GetPointerToData().

virtual void vtkImageExport::ImageLowerLeftOff | ( |  | ) | `[virtual]`

| Set/Get whether the data goes to the exported memory starting in the lower left corner or upper left corner. Default: On. When this flag is Off, the image will be flipped vertically before it is exported. WARNING: this flag is used only with the Export() method, it is ignored by GetPointerToData().

virtual int vtkImageExport::GetImageLowerLeft | ( |  | ) | `[virtual]`

| Set/Get whether the data goes to the exported memory starting in the lower left corner or upper left corner. Default: On. When this flag is Off, the image will be flipped vertically before it is exported. WARNING: this flag is used only with the Export() method, it is ignored by GetPointerToData().

virtual void vtkImageExport::SetImageLowerLeft | ( | int |  | ) | `[virtual]`

| Set/Get whether the data goes to the exported memory starting in the lower left corner or upper left corner. Default: On. When this flag is Off, the image will be flipped vertically before it is exported. WARNING: this flag is used only with the Export() method, it is ignored by GetPointerToData().

void vtkImageExport::SetExportVoidPointer | ( | void * |  | ) |

| Set the void pointer of the C array to export the data to. From python, you can specify a pointer to a string that is large enough to hold the data.

void* vtkImageExport::GetExportVoidPointer | ( |  | ) | `[inline]`

| Set the void pointer of the C array to export the data to. From python, you can specify a pointer to a string that is large enough to hold the data. Definition at line 122 of file vtkImageExport.h.

void vtkImageExport::Export | ( |  | ) | `[inline]`

| The main interface: update the pipeline and export the image to the memory pointed to by SetExportVoidPointer(). You can also specify a void pointer when you call Export(). Definition at line 129 of file vtkImageExport.h.

virtual void vtkImageExport::Export | ( | void * |  | ) | `[virtual]`

| The main interface: update the pipeline and export the image to the memory pointed to by SetExportVoidPointer(). You can also specify a void pointer when you call Export().

void* vtkImageExport::GetPointerToData | ( |  | ) |

| An alternative to Export(): Use with caution. Update the pipeline and return a pointer to the image memory. The pointer is only valid until the next time that the pipeline is updated. WARNING: This method ignores the ImageLowerLeft flag.

void* vtkImageExport::GetCallbackUserData | ( |  | ) |

| Get the user data that should be passed to the callback functions.

UpdateInformationCallbackType vtkImageExport::GetUpdateInformationCallback | ( |  | ) |

| Get pointers to the pipeline interface callbacks.

PipelineModifiedCallbackType vtkImageExport::GetPipelineModifiedCallback | ( |  | ) |

| Get pointers to the pipeline interface callbacks.

WholeExtentCallbackType vtkImageExport::GetWholeExtentCallback | ( |  | ) |

| Get pointers to the pipeline interface callbacks.

SpacingCallbackType vtkImageExport::GetSpacingCallback | ( |  | ) |

| Get pointers to the pipeline interface callbacks.

OriginCallbackType vtkImageExport::GetOriginCallback | ( |  | ) |

| Get pointers to the pipeline interface callbacks.

ScalarTypeCallbackType vtkImageExport::GetScalarTypeCallback | ( |  | ) |

| Get pointers to the pipeline interface callbacks.

NumberOfComponentsCallbackType vtkImageExport::GetNumberOfComponentsCallback | ( |  | ) |

| Get pointers to the pipeline interface callbacks.

PropagateUpdateExtentCallbackType vtkImageExport::GetPropagateUpdateExtentCallback | ( |  | ) |

| Get pointers to the pipeline interface callbacks.

UpdateDataCallbackType vtkImageExport::GetUpdateDataCallback | ( |  | ) |

| Get pointers to the pipeline interface callbacks.

DataExtentCallbackType vtkImageExport::GetDataExtentCallback | ( |  | ) |

| Get pointers to the pipeline interface callbacks.

BufferPointerCallbackType vtkImageExport::GetBufferPointerCallback | ( |  | ) |

| Get pointers to the pipeline interface callbacks.

virtual void vtkImageExport::UpdateInformationCallback | ( |  | ) | `[protected, virtual]`

virtual int vtkImageExport::PipelineModifiedCallback | ( |  | ) | `[protected, virtual]`

virtual void vtkImageExport::UpdateDataCallback | ( |  | ) | `[protected, virtual]`

virtual int* vtkImageExport::WholeExtentCallback | ( |  | ) | `[protected, virtual]`

virtual float* vtkImageExport::SpacingCallback | ( |  | ) | `[protected, virtual]`

virtual float* vtkImageExport::OriginCallback | ( |  | ) | `[protected, virtual]`

virtual const char* vtkImageExport::ScalarTypeCallback | ( |  | ) | `[protected, virtual]`

virtual int vtkImageExport::NumberOfComponentsCallback | ( |  | ) | `[protected, virtual]`

virtual void vtkImageExport::PropagateUpdateExtentCallback | ( | int * |  | ) | `[protected, virtual]`

virtual int* vtkImageExport::DataExtentCallback | ( |  | ) | `[protected, virtual]`

virtual void* vtkImageExport::BufferPointerCallback | ( |  | ) | `[protected, virtual]`

## Member Data Documentation

int vtkImageExport::ImageLowerLeft`[protected]`

| Definition at line 191 of file vtkImageExport.h.

int vtkImageExport::DataDimensions[3]`[protected]`

| Definition at line 192 of file vtkImageExport.h.

void* vtkImageExport::ExportVoidPointer`[protected]`

| Definition at line 193 of file vtkImageExport.h.

unsigned long vtkImageExport::LastPipelineMTime`[protected]`

| Definition at line 195 of file vtkImageExport.h.

The documentation for this class was generated from the following file:

- Imaging/vtkImageExport.h